<%- include('partials/header.ejs') %>

<!-- content start -->
<div class="main">
    <div class="d-flex head">
        <h2 class="heading">Subscription Plans :-</h2>
        <button
            type="button"
            class="btn btn-info ml-auto"
            data-toggle="modal"
            data-target="#add"
        >
            Add New
        </button>
    </div>
    <div class="content">
        <table
            id="doctor-category-table"
            class="table table-striped table-bordered add-button"
            style="width: 100%"
        >
            <thead>
                <tr>
                    <th class="text-center">Months</th>
                    <th class="text-center">Sessions</th>
                    <th class="text-center">Original Amount</th>
                    <th class="text-center">Amount</th>
                    <th class="text-center">Edit</th>
                    <th class="text-center">Delete</th>
                </tr>
            </thead>
            <tfoot></tfoot>
        </table>
    </div>
    <div>
        <!-- Add Category Modal -->
        <div class="modal fade" id="add">
            <div class="modal-dialog">
                <div class="modal-content">
                    <!-- Modal Header -->
                    <div class="modal-header">
                        <h4 class="modal-title">Add Plan</h4>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                        >
                            &times;
                        </button>
                    </div>

                    <!-- Modal body -->
                    <div class="modal-body">
                        <form id="addform" class="mx-5">
                            <div
                                class="mb-3"
                                id="previewicon"
                                style="display: none"
                            >
                                <center>
                                    <img
                                        src=""
                                        id="display_preview_icon"
                                        height="50px"
                                        width="50px"
                                    />
                                </center>
                            </div>
                            <div class="mb-3">
                                <label>No of Month: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="month"
                                    name="month"
                                    placeholder="No of Month"
                                />
                            </div>
                            <div class="mb-3">
                                <label>No of Sessions: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="sessions"
                                    name="sessions"
                                    placeholder="No of Sessions"
                                />
                            </div>
                            <div class="mb-3">
                                <label>Original Amount: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="original_amount"
                                    name="original_amount"
                                    placeholder="Original Amount"
                                />
                            </div>
                            <div class="mb-3">
                                <label>Offer Amount: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="amount"
                                    name="amount"
                                    placeholder="Amount"
                                />
                            </div>
                            <button
                                type="submit"
                                class="btn btn-info mt-3 pull-right"
                            >
                                Add
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <!-- Add Category Modal -->
        <div class="modal fade" id="edit">
            <div class="modal-dialog">
                <div class="modal-content">
                    <!-- Modal Header -->
                    <div class="modal-header">
                        <h4 class="modal-title">Edit Plan</h4>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                        >
                            &times;
                        </button>
                    </div>

                    <!-- Modal body -->
                    <div class="modal-body">
                        <form id="editform" class="mx-5">
                            <input type="hidden" id="editid" name="editid" />
                           
                           
                            <div class="mb-3">
                                <label>No of Month: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="month"
                                    name="month"
                                    placeholder="No of Month"
                                />
                            </div>
                            <div class="mb-3">
                                <label>No of Sessions: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="sessions"
                                    name="sessions"
                                    placeholder="No of Sessions"
                                />
                            </div>
                            <div class="mb-3">
                                <label>Original Amount: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="original_amount"
                                    name="original_amount"
                                    placeholder="Original Amount"
                                />
                            </div>
                            <div class="mb-3">
                                <label>Offer Amount: </label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="amount"
                                    name="amount"
                                    placeholder="Amount"
                                />
                            </div>
                            <button
                                type="submit"
                                class="btn btn-info mt-3 pull-right"
                            >
                                Add
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <%- include ('partials/footer.ejs') %>

        <script>
            activeSideBar("doctor-category");

            var table = $("#doctor-category-table").DataTable({
                serverSide: true,
                ajax: {
                    url: "datatable-data",
                    type: "POST",
                },
                columns: [
                    { data: "month" },
                    { data: "sessions" },
                    { data: "original_amount" },
                    { data: "amount" },
                    {
                        defaultContent: `<i id="edit_btn" class="material-icons table-icon btn text-primary"
                                    data-toggle="modal" data-target="#edit">edit</i>`,
                    },
                    {
                        defaultContent: `<i id="delete_btn"
                                        class="material-icons table-icon btn delete-icon">delete</i>`,
                    },
                ],
            });
            
            var addform = $("#addform");
            addform.on("submit", submitHandler);

            function submitHandler(e) {
                e.preventDefault();
                // vaidation
                if ($("#month").val() == "") {
                    alert("Month is required");
                    return false;
                }
                else if ($("#sessions").val() == "") {
                    alert("Sessions is required");
                    return false;
                }
                else if ($("#original_amount").val() == "") {
                    alert("Original Amount is required");
                    return false;
                }
                else if ($("#amount").val() == "") {
                    alert("Amount is required");
                    return false;
                }
                let data = {
                    original_amount : $("#original_amount").val(),
                    amount : $("#amount").val(),
                    sessions : $("#sessions").val(),
                    month : $("#month").val(),
                }
                
                // DO POST
                $.ajax({
                    type: "POST",
                    contentType: "application/json",
                    url: "add",
                    data: JSON.stringify(data)
                })
                    .done((res) => {
                        $("#add").modal("toggle");
                        $("#previewicon").hide();
                        $("#addform").trigger("reset");
                        table.draw();
                        Snackbar.show({
                            text: res,
                            pos: "bottom-right",
                            customClass: "snackbar-custom-s",
                            showAction: false,
                        });
                    })
                    .fail(function (xhr, status, error) {
                        $("#add").modal("toggle");
                        $("#previewicon").hide();
                        $("#addform").trigger("reset");
                        Snackbar.show({
                            text: xhr.responseText,
                            pos: "bottom-right",
                            customClass: "snackbar-custom-d",
                            showAction: false,
                        });
                    });
            }

            $(document).on("click", "#edit_btn", function (e) {
                var row = $(this).closest("tr");
                var data = table.row(row).data();
                console.log("data",data)
                $("#editid").val(data._id);
                $("#editform").find('#month').val(data.month);
                $("#editform").find('#sessions').val(data.sessions);
                $("#editform").find('#amount').val(data.amount);
                $("#editform").find('#original_amount').val(data.original_amount);
            });

            var editform = $("#editform");
            editform.on("submit", editSubmitHandler);

            function editSubmitHandler(e) {

                e.preventDefault();

                if ($("#editform").find('#month').val() == "") {
                    alert("Month is required");
                    return false;
                }
                else if ($("#editform").find('#sessions') == "") {
                    alert("Sessions is required");
                    return false;
                }
                else if ($("#editform").find('#amount') == "") {
                    alert("Amount is required");
                    return false;
                }
                else if ($("#editform").find('#original_amount') == "") {
                    alert("Original Amount is required");
                    return false;
                }
                let data = {
                    amount : $("#editform").find('#amount').val(),
                    original_amount : $("#editform").find('#original_amount').val(),
                    sessions : $("#editform").find('#sessions').val(),
                    month : $("#editform").find('#month').val(),
                    editid : $("#editform").find('#editid').val(),
                }
                
                // DO POST
                $.ajax({
                    type: "POST",
                    contentType: "application/json",
                    url: "edit",
                    data: JSON.stringify(data)
                })
                    .done((res) => {
                        table.draw();
                        Snackbar.show({
                            text: res,
                            pos: "bottom-right",
                            customClass: "snackbar-custom-s",
                            showAction: false,
                        });
                    })
                    .fail(function (xhr, status, error) {
                        Snackbar.show({
                            text: xhr.responseText,
                            pos: "bottom-right",
                            customClass: "snackbar-custom-d",
                            showAction: false,
                        });
                    });
            }

            $(document).on("click", "#delete_btn", function (e) {
                if (
                    confirm("Do you really want to delete this plan")
                ) {
                    var row = $(this).closest("tr");
                    tableData = table.row(row).data();
                    var id = tableData._id;
                    $.ajax({
                        type: "POST",
                        contentType: "application/json",
                        url: "delete",
                        data: JSON.stringify({
                            id: id,
                        }),
                    })
                        .done((res) => {
                            row.remove();
                            Snackbar.show({
                                text: res,
                                pos: "bottom-right",
                                customClass: "snackbar-custom-s",
                                showAction: false,
                            });
                        })
                        .fail(function (xhr, status, error) {
                            Snackbar.show({
                                text: xhr.responseText,
                                pos: "bottom-right",
                                customClass: "snackbar-custom-d",
                                showAction: false,
                            });
                        });
                }
            });

            $("#icon").change(function () {
                displayPP(this, $("#display_preview_icon"), $("#previewicon"));
            });

            $("#editicon").change(function () {
                displayPP(
                    this,
                    $("#editdisplay_preview_icon"),
                    $("#editpreviewicon")
                );
            });
        </script>
    </div>
</div>
